Loading...
Searching...
No Matches
MinCostArborescenceDefaultTraits< GR, CM > Struct Template Reference

## Detailed Description

template<class GR, class CM>
struct lemon::MinCostArborescenceDefaultTraits< GR, CM >

Default traits class for MinCostArborescence class.

Parameters

  GR | Digraph type.
  CM | Type of the cost map.

`#include <lemon/min_cost_arborescence.h>`

## Public Types

typedef GR | Digraph
| The digraph type the algorithm runs on.
typedef CM | CostMap
| The type of the map that stores the arc costs.
typedef CostMap::Value | Value
| The value type of the costs.
typedef Digraph::template ArcMap< bool > | ArborescenceMap
| The type of the map that stores which arcs are in the arborescence.
typedef Digraph::template NodeMap< typename Digraph::Arc > | PredMap
| The type of the `PredMap`.

## Static Public Member Functions

static ArborescenceMap * | createArborescenceMap (const Digraph &digraph)
| Instantiates a `ArborescenceMap`.
static PredMap * | createPredMap (const Digraph &digraph)
| Instantiates a `PredMap`.

## Member Typedef Documentation

## CostMap

template<class GR, class CM>

typedef CM CostMap

The type of the map that stores the arc costs. It must conform to the ReadMap concept.

## Value

template<class GR, class CM>

typedef CostMap::Value Value

The value type of the costs.

## ArborescenceMap

template<class GR, class CM>

typedef Digraph::template ArcMap<bool> ArborescenceMap

The type of the map that stores which arcs are in the arborescence. It must conform to the WriteMap concept, and its value type must be `bool` (or convertible). Initially it will be set to `false` on each arc, then it will be set on each arborescence arc once.

## PredMap

template<class GR, class CM>

typedef Digraph::template NodeMap<typename Digraph::Arc> PredMap

The type of the `PredMap`. It must confrom to the WriteMap concept, and its value type must be the `Arc` type of the digraph.

## Member Function Documentation

## createArborescenceMap()

template<class GR, class CM>

ArborescenceMap * createArborescenceMap | ( | const Digraph & | digraph | ) |

inline static

This function instantiates a `ArborescenceMap`.

Parameters

  digraph | The digraph to which we would like to calculate the `ArborescenceMap`.

## createPredMap()

template<class GR, class CM>

PredMap * createPredMap | ( | const Digraph & | digraph | ) |

inline static

This function instantiates a `PredMap`.

Parameters

  digraph | The digraph to which we would like to define the `PredMap`.